public class Top {
	public static void main(String[] args) {
		double alpha,beta,a,b,enegy,Ione,Ithree,omega0,mass,g,l,L0;
		double t,dt,u,ppsi,pphi,ra,rh,dd,umax,fumax,umin,up,kubun1,kubun2,ri;
		double[] theta =new double[50000];
		double[] tt =new double[50000];
		double[] psi =new double[50000];
		double[] phi =new double[50000];
		double[] xx =new double[50000];
		double[] yy =new double[50000];
		double[] zz =new double[50000];
		double[] uuu =new double[50000];
		int i,j,NNN=1,NNN1,NNN2,index,select;
		ppsi=0.0;
		pphi=0.0;
		select=2;
		rh=0.03;
		ra=0.02;
		l=0.04;
		mass=0.015;
		omega0=400.0;
		L0=0.0005;
		enegy=0.1477;
		if(select==2){
			rh=0.03;
			ra=0.02;
			l=0.03;
			mass=0.015;
			omega0=500.0;
			L0=0.0007;
			enegy=0.23;
		}
		if(select==3){
			rh=0.03;
			ra=0.02;
			l=0.04;
			mass=0.015;
			omega0=400.0;
			L0=0.000489796;
			enegy=0.148;
		}
		if(select==4){
			rh=0.03;
			ra=0.02;
			l=0.023;
			mass=0.015;
			omega0=420.0;
			L0=0.00048;
			enegy=0.16085;
		}
		Ione=(3.0/20.0*(rh*rh/4.0+ra*ra)+l*l)*mass;
		Ithree=3.0/10.0*ra*ra*mass;
		g=9.8;
		alpha=(2.0*enegy-Ithree*omega0*omega0)/Ione;
		beta=2.0*mass*g*l/Ione;
		a=L0/Ione;
		b=Ithree*omega0/Ione;
		dd=(alpha+b*b)*(alpha+b*b)-3.0*beta*(2.0*b*a-beta);
		up=(alpha+b*b-Math.sqrt(dd))/3.0/beta;
		fumax=(alpha-beta*up)*(1.0-up*up)-(a-b*up)*(a-b*up);
		kubun1=-1.0;
		kubun2=1.0;
		umin=NIBUN(kubun1,up,a,b,alpha,beta);
		umax=NIBUN(up,kubun2,a,b,alpha,beta);
		t=0.0;
		dt=0.0001;
		u=(umax+umin)/2.0;
		index=0;
		for(i=1;i<10000;i++){
			u=RK4(u,t,dt,a,b,alpha,beta,index);
			if(u<umin){
				NNN=i-1;
				break;
			}
			uuu[i]=u;
			theta[i]=Math.acos(uuu[i]);
			tt[i]=t;
		}

		for(j=1;j<8;j++){
			u=umin;
			index=1;
			for(i=NNN+1;i<10000;i++){
				u=RK4(u,t,dt,a,b,alpha,beta,index);
				if(u>umax){
					NNN=i-1;
					break;
				}
				uuu[i]=u;
				theta[i]=Math.acos(uuu[i]);
				tt[i]=t;
			}

			u=umax;
			index=0;
			for(i=NNN+1;i<10000;i++){
				u=RK4(u,t,dt,a,b,alpha,beta,index);
				if(u<umin){
					NNN=i-1;
					break;
				}
				uuu[i]=u;
				theta[i]=Math.acos(uuu[i]);
				tt[i]=t;
			}
		}
		for(i=1;i<NNN;i++){
			u=uuu[i];
			t=tt[i];
			ppsi=RK42(ppsi,u,t,dt,a,b);
			pphi=RK43(pphi,u,t,dt,a,b,omega0);
			psi[i]=ppsi;
			phi[i]=pphi;
		}
		ri=0.5;
		for(i=1;i<NNN;i++){
			xx[i]=ri*Math.sqrt(1.0-uuu[i]*uuu[i])*Math.sin(psi[i]);
			yy[i]=-ri*Math.sqrt(1.0-uuu[i]*uuu[i])*Math.cos(psi[i]);
			zz[i]=ri*uuu[i];
		}
		for(i=1;i<NNN;i++){
			System.out.println(xx[i]+ ", "+ yy[i]+ ", "+ zz[i]);
		}
	}
	public static double RK4(double x, double t, double dt, double a, double b, double alpha, double beta, int index){
		double kx1,ky1,kx2,ky2,kx3,ky3,kx4,ky4,ff;
		kx1=dt*ff(x,a,b,alpha,beta,index);
		kx2=dt*ff(x+0.5*kx1,a,b,alpha,beta,index);
		kx3=dt*ff(x+0.5*kx2,a,b,alpha,beta,index);
		kx4=dt*ff(x+kx3,a,b,alpha,beta,index);
		t=t+dt;
		return x+(kx1+2.0*kx2+2.0*kx3+kx4)/6.0;
	}
	public static double RK42(double x, double u, double t, double dt, double a, double b){
		double kx1,ky1,kx2,ky2,kx3,ky3,kx4,ky4,ff2;
		kx1=dt*ff2(u,a,b);
		kx2=dt*ff2(u+0.5*kx1,a,b);
		kx3=dt*ff2(u+0.5*kx2,a,b);
		kx4=dt*ff2(u+kx3,a,b);
		return x+(kx1+2.0*kx2+2.0*kx3+kx4)/6.0;
	}
	public static double RK43(double x, double u, double t, double dt, double a, double b, double omega0){
		double kx1,ky1,kx2,ky2,kx3,ky3,kx4,ky4,ff3;
		kx1=dt*ff3(u,a,b,omega0);
		kx2=dt*ff3(u+0.5*kx1,a,b,omega0);
		kx3=dt*ff3(u+0.5*kx2,a,b,omega0);
		kx4=dt*ff3(u+kx3,a,b,omega0);
		return x+(kx1+2.0*kx2+2.0*kx3+kx4)/6.0;
	}
	public static double ff(double u, double a, double b, double alpha, double beta, double index){
		double ff,t;
		ff = (alpha-beta*u)*(1.0-u*u)-(a-b*u)*(a-b*u);
		if(index==1) ff = Math.sqrt(Math.abs(ff));
		if(index==0) ff =-Math.sqrt(Math.abs(ff));
		return ff;
	}
	public static double gg(double u, double a, double b, double alpha, double beta){
		double gg,t;
		return gg = (alpha-beta*u)*(1.0-u*u)-(a-b*u)*(a-b*u);
	}
	public static double ff2(double u, double a, double b){
		double ff2;
		return ff2 = (a-b*u)/(1.0-u*u);
	}
	public static double ff3(double u, double a, double b, double omega0){
		double ff3;
		return ff3 = omega0-(a-b*u)/(1.0-u*u)*u;
	}
	public static double NIBUN(double low, double high, double a, double b, double alpha, double beta){
		double mid,gg;
		int i;
		for(i=1;i<1000;i++){
			mid=(low+high)/2.0;
			if(gg(low,a,b,alpha,beta)*gg(mid,a,b,alpha,beta)<0.0){
				high = mid;
			} else {
				low = mid;
			}
			if(Math.abs(high-low)<1.0e-10){
				break;
			}
		}
		return (high+low)/2.0;
	}
}
